--
-- magnum7140
-- Specialization for magnum tractors
--
-- @author  Knagsted
-- @date  15/03/10
--

-- Do not edit without my permission
--
magnum7140 = {}

function magnum7140.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function magnum7140:load(xmlFile)
	self.numHeadLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.headLights#count"), 0);
    self.headLights = {};
    for i=1, self.numHeadLights do
        local headLightsNamei = string.format("vehicle.headLights.headLight" .. "%d", i);
        self.headLights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, headLightsNamei .. "#index"));
        setVisibility(self.headLights[i], false);
    end;

	self.numFrontWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontWorkLights#count"), 0);
    self.frontWorkLights = {};
    for i=1, self.numFrontWorkLights do
        local frontWorkLightsNamei = string.format("vehicle.frontWorkLights.frontWorkLight" .. "%d", i);
        self.frontWorkLights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontWorkLightsNamei .. "#index"));
        setVisibility(self.frontWorkLights[i], false);
    end;
	
	self.numWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.workLights#count"), 0);
    self.workLights = {};
    for i=1, self.numWorkLights do
        local workLightsNamei = string.format("vehicle.workLights.workLight" .. "%d", i);
        self.workLights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, workLightsNamei .. "#index"));
        setVisibility(self.workLights[i], false);
    end;
	
	-- Digital Display digits RPM
	self.numDigitRPMOne = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitRPMOne#count"), 0);
	self.digitRPMOne = {};
    for i=1, self.numDigitRPMOne do
        local objname = string.format("vehicle.displayDigitRPMOne.digitRPM" .. "%d", i);
		self.digitRPMOne[i] = {};
        self.digitRPMOne[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitRPMOne[i].rotNode,false);
    end;
	setVisibility(self.digitRPMOne[self.numDigitRPMOne].rotNode,true);
	
	self.numDigitRPMTwo = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitRPMTwo#count"), 0);
	self.digitRPMTwo = {};
    for i=1, self.numDigitRPMTwo do
        local objname = string.format("vehicle.displayDigitRPMTwo.digitRPM" .. "%d", i);
		self.digitRPMTwo[i] = {};
        self.digitRPMTwo[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitRPMTwo[i].rotNode,false);
    end;
	setVisibility(self.digitRPMTwo[self.numDigitRPMTwo].rotNode,true);

	self.numDigitRPMThree = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitRPMThree#count"), 0);
	self.digitRPMThree = {};
    for i=1, self.numDigitRPMThree do
        local objname = string.format("vehicle.displayDigitRPMThree.digitRPM" .. "%d", i);
		self.digitRPMThree[i] = {};
        self.digitRPMThree[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitRPMThree[i].rotNode,false);
    end;
	setVisibility(self.digitRPMThree[self.numDigitRPMThree].rotNode,true);
	
	self.numDigitRPMFour = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitRPMFour#count"), 0);
	self.digitRPMFour = {};
    for i=1, self.numDigitRPMFour do
        local objname = string.format("vehicle.displayDigitRPMFour.digitRPM" .. "%d", i);
		self.digitRPMFour[i] = {};
        self.digitRPMFour[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitRPMFour[i].rotNode,false);
    end;
	setVisibility(self.digitRPMFour[self.numDigitRPMFour].rotNode,true);
	
	-- Digital Display digits Speed
	self.numDigitSPEEDOne = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitSPEEDOne#count"), 0);
	self.digitSPEEDOne = {};
    for i=1, self.numDigitSPEEDOne do
        local objname = string.format("vehicle.displayDigitSPEEDOne.digitSPEED" .. "%d", i);
		self.digitSPEEDOne[i] = {};
        self.digitSPEEDOne[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitSPEEDOne[i].rotNode,false);
    end;
	setVisibility(self.digitSPEEDOne[self.numDigitSPEEDOne].rotNode,true);
	
	self.numDigitSPEEDTwo = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitSPEEDTwo#count"), 0);
	self.digitSPEEDTwo = {};
    for i=1, self.numDigitSPEEDTwo do
        local objname = string.format("vehicle.displayDigitSPEEDTwo.digitSPEED" .. "%d", i);
		self.digitSPEEDTwo[i] = {};
        self.digitSPEEDTwo[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitSPEEDTwo[i].rotNode,false);
    end;
	setVisibility(self.digitSPEEDTwo[self.numDigitSPEEDTwo].rotNode,true);

	self.numDigitSPEEDThree = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitSPEEDThree#count"), 0);
	self.digitSPEEDThree = {};
    for i=1, self.numDigitSPEEDThree do
        local objname = string.format("vehicle.displayDigitSPEEDThree.digitSPEED" .. "%d", i);
		self.digitSPEEDThree[i] = {};
        self.digitSPEEDThree[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitSPEEDThree[i].rotNode,false);
    end;
	setVisibility(self.digitSPEEDThree[self.numDigitSPEEDThree].rotNode,true);
	
	self.numDigitSPEEDFour = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayDigitSPEEDFour#count"), 0);
	self.digitSPEEDFour = {};
    for i=1, self.numDigitSPEEDFour do
        local objname = string.format("vehicle.displayDigitSPEEDFour.digitSPEED" .. "%d", i);
		self.digitSPEEDFour[i] = {};
        self.digitSPEEDFour[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.digitSPEEDFour[i].rotNode,false);
    end;
	setVisibility(self.digitSPEEDFour[self.numDigitSPEEDFour].rotNode,true);
	
	self.numFuelMeter = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.displayFuelMeter#count"), 0);
	self.fuelMeter = {};
    for i=1, self.numFuelMeter do
        local objname = string.format("vehicle.displayFuelMeter.meter" .. "%d", i);
		self.fuelMeter[i] = {};
        self.fuelMeter[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.fuelMeter[i].rotNode,false);
    end;
	setVisibility(self.fuelMeter[self.numFuelMeter].rotNode,true);
	
	-- Rear lift animation
	self.lifter = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifter#index"));
	self.lifterAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterAttacher#index"));
	self.lifterArmLower = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterArmLower#index"));
	self.lifterArmLowerAttacherJoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterArmLowerAttacherJoint#index"));
	self.push1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.push1#index"));
	self.push2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.push2#index"));
	self.hydraulics1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulics1#index"));
	self.hydraulics2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulics2#index"));
	self.hydraulicsJoint1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicsJoint1#index"));
	self.hydraulicsJoint2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicsJoint2#index"));
	
	-- Front axle animation
	self.frontAxle = {};
	self.frontAxle.rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#rotNode"));
	self.frontAxle.steeringPush = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPush"));
	self.frontAxle.steeringPushLeftAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushLeftAttach"));
	self.frontAxle.steeringPushRightAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushRightAttach"));
	
	self.numAnimatedWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.animatedWheels#count"), 0);
	self.animatedWheel = {};
    for i=1, self.numAnimatedWheels do
        local objname = string.format("vehicle.animatedWheels.wheel" .. "%d", i);
		self.animatedWheel[i] = {};
        self.animatedWheel[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		self.animatedWheel[i].wheel = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#wheelIndex"));
		self.animatedWheel[i].fenderAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#fenderAttach"));
    end;
	
	-- Moveable camera
	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	
	
	-- Switches leavers etc
	self.liftSwitch = {}; 
	self.liftSwitch.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftSwitch#index"));
	self.liftSwitch.off = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftSwitch#off"));
	self.liftSwitch.on = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftSwitch#on"));
	
	self.liftLeaver = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftLeaver#index"));
	self.liftLeaverRelationship = 0;
	if self.attacherJoints[1].maxRot[1] ~= nil and self.attacherJoints[1].minRot[1] ~= nil then
		self.liftLeaverRelationship = (self.attacherJoints[1].minRot[1] + self.attacherJoints[1].maxRot[1])/Utils.degToRad(26);
	end;
	
	local doorNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.door#index"));
    if doorNode ~= nil then
        self.door = {};
        self.door.node = doorNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.door#minRot"));
        self.door.minRot = {};
        self.door.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.door.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.door.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.door#maxRot"));
        self.door.maxRot = {};
        self.door.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.door.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.door.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.door.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.door#rotTime"), 200);
        self.door.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.door#touchRotLimit"), 10));
    end;
	
	local rearWindowNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rearWindow#index"));
    if rearWindowNode ~= nil then
        self.rearWindow = {};
        self.rearWindow.node = rearWindowNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rearWindow#minRot"));
        self.rearWindow.minRot = {};
        self.rearWindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rearWindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rearWindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rearWindow#maxRot"));
        self.rearWindow.maxRot = {};
        self.rearWindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rearWindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rearWindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rearWindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rearWindow#rotTime"), 200);
        self.rearWindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rearWindow#touchRotLimit"), 10));
    end;
	
	self.lightSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightSwitch#index"));
	
	self.frontLightMode = 0;
	self.headLightActive = false;
	self.frontWorkLightActive = false;
	self.workLightActive = false;
	
	self.displayValue = 0;
	self.prevousDigitRPMFour = self.numDigitRPMFour;
	self.prevousDigitRPMThree = self.numDigitRPMThree;
	self.prevousDigitRPMTwo = self.numDigitRPMTwo;
	self.prevousDigitRPMOne = 0;
	
	self.prevousDigitSPEEDFour = self.numDigitSPEEDFour;
	self.prevousDigitSPEEDThree = self.numDigitSPEEDThree;
	self.prevousDigitSPEEDTwo = self.numDigitSPEEDTwo;
	self.prevousDigitSPEEDOne = self.numDigitSPEEDOne;
	
	self.prevousFuelPercentage = 0;
	
	self.cycleRoundMax = 30;
	self.currentCycle = 0;
	self.lastRpm = 0;
	
	self.lifterStartAngle = 0;
	
	self.startAngel1 = 0;
	self.startAngel2 = 0;
	self.startTranslation = 0;
	self.liftInitialized = false;
	self.shiftMode = 1;
	self.lastLiftXRot = 0;
	
	self.mirrorsEnabled = false;
	self.leftMirrorGlass = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.leftMirrorGlass#index"));
	self.rightMirrorGlass = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rightMirrorGlass#index"));	
	self.leftMirror = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.leftMirror#index"));
	self.rightMirror = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rightMirror#index"));
	
	if self.mirrorRotationOffsetXleft == nil then
		self.mirrorRotationOffsetXleft = 0;
	end;
	
	if self.mirrorRotationOffsetYleft == nil then
		self.mirrorRotationOffsetYleft = 0;
	end;

	if self.mirrorRotationOffsetXright == nil then
		self.mirrorRotationOffsetXright = 0;
	end;

	if self.mirrorRotationOffsetYright == nil then
		self.mirrorRotationOffsetYright = 0;
	end;
	
	if self.camPositionX == nil then
		self.camPositionX = 0;
	end;
	
	if self.camPositionZ == nil then
		self.camPositionZ = 0;
	end;
end;
      
function magnum7140:delete()
end;

function magnum7140:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function magnum7140:keyEvent(unicode, sym, modifier, isDown)
end;

function magnum7140:update(dt)
	-- Front axle animation
	if self.attacherJoints[1] ~= nil then
		if self.attacherJoints[1].maxRot[1] ~= nil then
			if not self.liftInitialized then
				self.maxLiftDebth = self.attacherJoints[1].maxRot[1];
				self.minLiftDebth = self.attacherJoints[1].minRot[1];
				self.liftInitialized = true;
			end;
		end;
	end;
				
	if self.frontAxle.rotNode ~= nil and self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local ax, ay, az = getWorldTranslation(self.wheels[1].repr);
        local bx, by, bz = getWorldTranslation(self.wheels[2].repr);
		
		local yDiff = by-ay;
		local xDiff = 2 * 0.88;
		
		local angle = 0;
		if yDiff ~= 0 then
			angle = yDiff/math.tan(xDiff);
		end;

		setRotation(self.frontAxle.rotNode,0,0,angle);
	end;
	
	for i=1, self.numAnimatedWheels do
		if self.wheels[i].repr ~= nil then
			local x,y,z = getRotation(self.wheels[i].driveNode);
			local x2,y2,z2 = getRotation(self.wheels[i].repr);
			setRotation(self.animatedWheel[i].wheel, x,y,z);
			setRotation(self.animatedWheel[i].rotNode, x2,y2,z2);
		end;
	end;
	
	if self.frontAxle.steeringPushLeftAttach ~= nil and self.animatedWheel[1].fenderAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringPushLeftAttach);
        local bx, by, bz = getWorldTranslation(self.animatedWheel[1].fenderAttach);
        local cx, cy, cz = getWorldTranslation(self.frontAxle.rotNode);
		
		local zDiff = bz-az;
		local xDiff = bx-ax;
		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringPushLeftAttach), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringPushLeftAttach, x, y, z, 0, 1, 0);
		
		local x2,y2,z2 = getRotation(self.frontAxle.steeringPushLeftAttach);
		setRotation(self.frontAxle.steeringPushLeftAttach,x2,y2+4.71,z2);

		local x,y,z = getRotation(self.animatedWheel[1].rotNode);
		self.translation = -0.2094 * math.tan(y);
		setTranslation(self.frontAxle.steeringPush,(self.translation)*0.81,0,0);	
	end;
	
	if self.frontAxle.steeringPushRightAttach ~= nil and self.animatedWheel[2].fenderAttach ~= nil and self.frontAxle.steeringPush ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringPushRightAttach);
        local bx, by, bz = getWorldTranslation(self.animatedWheel[2].fenderAttach);
		--local cx, cy, cz = getWorldTranslation(self.frontAxle.rotNode);
		
		local zDiff = bz-az;
		local xDiff = bx-ax;
		
		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringPushRightAttach), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringPushRightAttach, x, y, z, 0, 1, 0);
		
		local x2,y2,z2 = getRotation(self.frontAxle.steeringPushRightAttach);
		setRotation(self.frontAxle.steeringPushRightAttach,x2,y2-4.71,z2);
	end;
	
	if self.door ~= nil then
		local x, y, z = getRotation(self.door.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.door.minRot, self.door.maxRot, 3, self.door.rotTime, dt, self.openDoor);
		setRotation(self.door.node, unpack(newRot));
	end;

	if self.rearWindow ~= nil then
		local x, y, z = getRotation(self.rearWindow.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rearWindow.minRot, self.rearWindow.maxRot, 3, self.rearWindow.rotTime, dt, self.openrearWindow);
		setRotation(self.rearWindow.node, unpack(newRot));
	end;

	-- Input reading
	if self.isEntered then
		if InputBinding.hasEvent(InputBinding.LIGHTSCYCLE) then
			self.frontLightMode = self.frontLightMode + 1;
			if self.frontLightMode > 5 then
				self.frontLightMode = 0;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMLEFT) then
			if 	self.shiftMode == 1 then
				self.camPositionX = self.camPositionX + 0.02;
				if self.camPositionX >= 0.5 then
					self.camPositionX = 0.5;
				end;
			elseif self.shiftMode == 2 then
				self.mirrorRotationOffsetYleft = self.mirrorRotationOffsetYleft + 0.5;
			elseif self.shiftMode == 3 then
				self.mirrorRotationOffsetYright = self.mirrorRotationOffsetYright + 0.5;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMRIGHT) then
			if 	self.shiftMode == 1 then
				self.camPositionX = self.camPositionX - 0.02;
				if self.camPositionX <= -0.5 then
					self.camPositionX = -0.5;
				end;
			elseif self.shiftMode == 2 then
				self.mirrorRotationOffsetYleft = self.mirrorRotationOffsetYleft - 0.5;
			elseif self.shiftMode == 3 then
				self.mirrorRotationOffsetYright = self.mirrorRotationOffsetYright - 0.5;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMFORWARD) then
			if 	self.shiftMode == 1 then
				self.camPositionZ = self.camPositionZ + 0.02;
				if self.camPositionZ >= 0.5 then
					self.camPositionZ = 0.5;
				end;
			elseif self.shiftMode == 2 then
				self.mirrorRotationOffsetXleft = self.mirrorRotationOffsetXleft + 0.5;
			elseif self.shiftMode == 3 then
				self.mirrorRotationOffsetXright = self.mirrorRotationOffsetXright + 0.5;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMBACK) then
			if 	self.shiftMode == 1 then
				self.camPositionZ = self.camPositionZ - 0.02;
				if self.camPositionZ <= -0.4 then
					self.camPositionZ = -0.4;
				end;
			elseif self.shiftMode == 2 then
				self.mirrorRotationOffsetXleft = self.mirrorRotationOffsetXleft - 0.5;
			elseif self.shiftMode == 3 then
				self.mirrorRotationOffsetXright = self.mirrorRotationOffsetXright - 0.5;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.MOVECAMRESET) then
			if 	self.shiftMode == 1 then
				self.camPositionX = 0;
				self.camPositionZ = 0;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.SHIFT) then
			self.shiftMode = self.shiftMode + 1;
			if self.shiftMode > 3 then
				self.shiftMode = 1;
			end;
		end;

		if InputBinding.hasEvent(InputBinding.ACTIVATEMIRRORS) then
			self.mirrorsEnabled = not self.mirrorsEnabled;
		end;
		
		if InputBinding.hasEvent(InputBinding.OPENLEFTDOOR) then
			self.openDoor = not self.openDoor;
		end;
		
		if InputBinding.hasEvent(InputBinding.REARWINDOW) then
			self.openrearWindow = not self.openrearWindow;
		end;
		
		if InputBinding.isPressed(InputBinding.INCREASELIFTDEBTH) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot[1] ~= nil then
					if self.attacherJoints[1].maxRot[1] > self.maxLiftDebth then
						self.attacherJoints[1].maxRot[1] = self.attacherJoints[1].maxRot[1] - 0.005;
					end;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.DECRESELIFTDEBTH) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot[1] ~= nil then
					if self.attacherJoints[1].maxRot[1] < self.minLiftDebth then
						self.attacherJoints[1].maxRot[1] = self.attacherJoints[1].maxRot[1] + 0.005;
					end;
				end;
			end;
		end;
	end;
	
	-- lift switch and leaver
	if self.attacherJoints[1].rotationNode ~= nil then
		
		--renderText(0.5, 0.42, 0.020, string.format("min rot=" .. "%f", self.attacherJoints[1].minRot[1]));
		--renderText(0.5, 0.40, 0.020, string.format("max rot=" .. "%f", self.attacherJoints[1].maxRot[1]));
		--renderText(0.5, 0.38, 0.020, string.format("current rot=" .. "%f", x));
		--renderText(0.5, 0.36, 0.020, string.format("self.liftLeaverRelationship=" .. "%f", self.liftLeaverRelationship));
		
		
		local x,y,z = getRotation(self.attacherJoints[1].rotationNode);
		if x < self.lastLiftXRot then
			setRotation(self.liftSwitch.node, Utils.degToRad(10),0,0);
			setVisibility(self.liftSwitch.off, true);
			setVisibility(self.liftSwitch.on, false);
		elseif x > self.lastLiftXRot then
			setRotation(self.liftSwitch.node, Utils.degToRad(-10),0,0);
			setVisibility(self.liftSwitch.off, false);
			setVisibility(self.liftSwitch.on, true);
		end;
		self.lastLiftXRot = x; 
	end;
		
	if self.liftLeaver ~= nil then
		setRotation(self.liftLeaver, (self.attacherJoints[1].maxRot[1] * self.liftLeaverRelationship), 0 ,0);
	end;
	
	-- Mirrors
	if self.leftMirrorGlass ~= nil then
		setVisibility(self.leftMirrorGlass,self.mirrorsEnabled);
	end;
	
	if self.rightMirrorGlass ~= nil then
		setVisibility(self.rightMirrorGlass,self.mirrorsEnabled);
	end;
	
	if self.leftMirror ~= nil then
		setRotation(self.leftMirror,Utils.degToRad(-self.mirrorRotationOffsetXleft),Utils.degToRad(226.5-self.mirrorRotationOffsetYleft),Utils.degToRad(0));
	end;
	
	if self.rightMirror ~= nil then
		setRotation(self.rightMirror,Utils.degToRad(-self.mirrorRotationOffsetXright),Utils.degToRad(self.mirrorRotationOffsetYright),Utils.degToRad(0));
	end;
	
	-- Camera translation
	if self.internalCamera ~= nil then
		setTranslation(self.internalCamera, self.camPositionX, 0, self.camPositionZ);
	end;
	
	-- lights
	if self.frontLightMode == 0  then
		self.headLightActive = false;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(0), 0);
		end;
	elseif self.frontLightMode == 1 or self.frontLightMode == 5 then
		self.headLightActive = true;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(-55), 0);
		end;
	elseif self.frontLightMode == 2 or self.frontLightMode == 4 then
		self.headLightActive = true;
		self.workLightActive = true;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(-75), 0);
		end;
	elseif self.frontLightMode == 3 then
		self.headLightActive = false;
		self.workLightActive = true;
		self.frontWorkLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(-100), 0);
		end;
	end;
	
	for i=1, self.numHeadLights do
		setVisibility(self.headLights[i], self.headLightActive);
	end;
	
	for i=1, self.numFrontWorkLights do
		setVisibility(self.frontWorkLights[i], self.frontWorkLightActive);
	end;
	
	for i=1, self.numWorkLights do
		setVisibility(self.workLights[i], self.workLightActive);
	end;
	
	-- Digital Display handling RPM
	if self.isEntered then
		--setVisibility(self.digitRPMTwo[1].rotNode,false);
		--if self.displaySelectorMode == 0 then
		
		if self.currentCycle < self.cycleRoundMax then
			self.currentCycle = self.currentCycle + 1;
			self.currentRPM = self.motor.lastMotorRpm;
			if self.rpmMeterValue ~= nil then
				self.currentRPM = self.rpmMeterValue;
			end;
			self.lastRpm = math.floor((self.lastRpm + self.currentRPM)/2);
		else
			self.currentCycle = 0;
			self.displayValue = self.lastRpm;
		end;
		
		--end;
		local displayValue = self.displayValue;
		
		--if self.displaySelectorMode == 1 then
			--displayValue = math.floor(displayValue);
		--end;

		-- Handle the digitRPMs in the display
		--if self.isMotorStarted then
			local thousends = math.floor(displayValue/1000);
			local displayIndex = thousends;
			if self.prevousDigitRPMFour ~= thousends then
				if self.prevousDigitRPMFour > 0 then
					setVisibility(self.digitRPMFour[self.prevousDigitRPMFour].rotNode,false);
				end;
				if displayIndex == 0 then
					displayIndex = self.numDigitRPMFour; 
				end;
				setVisibility(self.digitRPMFour[displayIndex].rotNode,true);
			end;
			self.prevousDigitRPMFour = displayIndex;
				
			displayValue = displayValue - thousends * 1000;
			local hundreds = math.floor(displayValue/100);
			displayIndex = hundreds;
			if self.prevousDigitRPMThree ~= hundreds then
				if self.prevousDigitRPMThree > 0 then
					setVisibility(self.digitRPMThree[self.prevousDigitRPMThree].rotNode,false);
				end;
				if displayIndex == 0 and thousends == 0 then
					displayIndex = self.numDigitRPMThree;
				elseif displayIndex == 0 then 
					if thousends > 0 then
						displayIndex = 10;
					end;
				end;
				setVisibility(self.digitRPMThree[displayIndex].rotNode,true);
			end;
			self.prevousDigitRPMThree = displayIndex;
			
			displayValue = displayValue - hundreds * 100;
			local tens = math.floor(displayValue/10);
			displayIndex = tens;
			if self.prevousDigitRPMTwo ~= tens then
				if self.prevousDigitRPMTwo > 0 then
					setVisibility(self.digitRPMTwo[self.prevousDigitRPMTwo].rotNode,false);
				end;
				if displayIndex == 0 and hundreds == 0 then
					displayIndex = self.numDigitRPMTwo;
				elseif displayIndex == 0 then 
					if hundreds > 0 or thousends > 0 then
						displayIndex = 10;
					end;
				end;
				setVisibility(self.digitRPMTwo[displayIndex].rotNode,true);
			end;
			self.prevousDigitRPMTwo = displayIndex;
			
			displayValue = displayValue - tens * 10;
			local ones = math.floor(displayValue);
			displayIndex = 10;
			--if self.prevousDigitRPMOne ~= ones then
				--if self.prevousDigitRPMOne > 0 then
					setVisibility(self.digitRPMOne[displayIndex+1].rotNode,false);
				--end;

				--if displayIndex == 0 then
					--displayIndex = 10;
				--end;
				--renderText(0.5, 0.65, 0.040, string.format(displayIndex));
				setVisibility(self.digitRPMOne[displayIndex].rotNode,true);
			--end;
			--self.prevousDigitRPMOne = displayIndex;
		--else
			--if self.prevousDigitRPMThree > 0 then
				--setVisibility(self.digitRPMThree[self.prevousDigitRPMThree].rotNode,false);
			--end;
			--self.prevousDigitRPMOne = self.numDigitRPMOne;
			--if self.prevousDigitRPMThree > 0 then
				--setVisibility(self.digitRPMThree[self.prevousDigitRPMThree].rotNode,false);
			--end;
			--self.prevousDigitRPMTwo = self.numDigitRPMTwo;
			--if self.prevousDigitRPMTwo > 0 then
				--setVisibility(self.digitRPMTwo[self.prevousDigitRPMTwo].rotNode,false);
			--end;
			--self.prevousDigitRPMThree = self.numDigitRPMThree;
			--if self.prevousDigitRPMOne > 0 then
				--setVisibility(self.digitRPMOne[self.prevousDigitRPMOne].rotNode,false);
			--end;
			--self.prevousDigitRPMFour = self.numDigitRPMFour;
			--setVisibility(self.digitRPMOne[self.numDigitRPMOne].rotNode,true);
			--setVisibility(self.digitRPMTwo[self.numDigitRPMTwo].rotNode,true);
			--setVisibility(self.digitRPMThree[self.numDigitRPMThree].rotNode,true);
			--setVisibility(self.digitRPMTwo[self.numDigitRPMFour].rotNode,true);
		--end;
	end;
	
	-- Digital Display handling Speed
	if self.isEntered then
		setVisibility(self.digitSPEEDTwo[11].rotNode,true);
		--if self.displaySelectorMode == 0 then
		
		--end;
		local displayValueSpeed = math.floor(self.lastSpeed * 3600 * 100);
		displayValueSpeed = displayValueSpeed/10;
		
		--if self.displaySelectorMode == 1 then
			--displayValueSpeed = math.floor(displayValueSpeed);
		--end;

		-- Handle the digitSPEEDs in the display
		--if self.isMotorStarted then
			local thousends = math.floor(displayValueSpeed/1000);
			local displayIndex = thousends;
			if self.prevousDigitSPEEDFour ~= thousends then
				if self.prevousDigitSPEEDFour > 0 then
					setVisibility(self.digitSPEEDFour[self.prevousDigitSPEEDFour].rotNode,false);
				end;
				if displayIndex == 0 then
					displayIndex = self.numDigitSPEEDFour; 
				end;
				setVisibility(self.digitSPEEDFour[displayIndex].rotNode,true);
			end;
			self.prevousDigitSPEEDFour = displayIndex;
				
			displayValueSpeed = displayValueSpeed - thousends * 1000;
			local hundreds = math.floor(displayValueSpeed/100);
			displayIndex = hundreds;
			if self.prevousDigitSPEEDThree ~= hundreds then
				if self.prevousDigitSPEEDThree > 0 then
					setVisibility(self.digitSPEEDThree[self.prevousDigitSPEEDThree].rotNode,false);
				end;
				if displayIndex == 0 and thousends == 0 then
					displayIndex = self.numDigitSPEEDThree;
				elseif displayIndex == 0 then 
					if thousends > 0 then
						displayIndex = 10;
					end;
				end;
				setVisibility(self.digitSPEEDThree[displayIndex].rotNode,true);
			end;
			self.prevousDigitSPEEDThree = displayIndex;
			
			displayValueSpeed = displayValueSpeed - hundreds * 100;
			local tens = math.floor(displayValueSpeed/10);
			displayIndex = tens;
			if self.prevousDigitSPEEDTwo ~= tens then
				if self.prevousDigitSPEEDTwo > 0 then
					setVisibility(self.digitSPEEDTwo[self.prevousDigitSPEEDTwo].rotNode,false);
				end;
				if displayIndex == 0 and hundreds == 0 then
					displayIndex = 10;
				elseif displayIndex == 0 then 
					if hundreds > 0 or thousends > 0 then
						displayIndex = 10;
					end;
				end;
				setVisibility(self.digitSPEEDTwo[displayIndex].rotNode,true);
			end;
			self.prevousDigitSPEEDTwo = displayIndex;
			
			displayValueSpeed = displayValueSpeed - tens * 10;
			local ones = math.floor(displayValueSpeed);
			displayIndex = ones;
			if self.prevousDigitSPEEDOne ~= ones then
				if self.prevousDigitSPEEDOne > 0 then
					setVisibility(self.digitSPEEDOne[self.prevousDigitSPEEDOne].rotNode,false);
				end;

				if displayIndex == 0 then
					displayIndex = 10;
				end;
				--renderText(0.5, 0.65, 0.040, string.format(displayIndex));
				setVisibility(self.digitSPEEDOne[displayIndex].rotNode,true);
			end;
			self.prevousDigitSPEEDOne = displayIndex;
		--else
			--if self.prevousDigitSPEEDThree > 0 then
				--setVisibility(self.digitSPEEDThree[self.prevousDigitSPEEDThree].rotNode,false);
			--end;
			--self.prevousDigitSPEEDOne = self.numDigitSPEEDOne;
			--if self.prevousDigitSPEEDThree > 0 then
				--setVisibility(self.digitSPEEDThree[self.prevousDigitSPEEDThree].rotNode,false);
			--end;
			--self.prevousDigitSPEEDTwo = self.numDigitSPEEDTwo;
			--if self.prevousDigitSPEEDTwo > 0 then
				--setVisibility(self.digitSPEEDTwo[self.prevousDigitSPEEDTwo].rotNode,false);
			--end;
			--self.prevousDigitSPEEDThree = self.numDigitSPEEDThree;
			--if self.prevousDigitSPEEDOne > 0 then
				--setVisibility(self.digitSPEEDOne[self.prevousDigitSPEEDOne].rotNode,false);
			--end;
			--self.prevousDigitSPEEDFour = self.numDigitSPEEDFour;
			--setVisibility(self.digitSPEEDOne[self.numDigitSPEEDOne].rotNode,true);
			--setVisibility(self.digitSPEEDTwo[self.numDigitSPEEDTwo].rotNode,true);
			--setVisibility(self.digitSPEEDThree[self.numDigitSPEEDThree].rotNode,true);
			--setVisibility(self.digitSPEEDTwo[self.numDigitSPEEDFour].rotNode,true);
		--end;
	end;
	
	-- Digital Fuel meter
	
	local currentFuelPercentage = self.fuelFillLevel / self.fuelCapacity;
	currentFuelPercentage = currentFuelPercentage * 10;
	if self.isEntered and self.prevousFuelPercentage ~= currentFuelPercentage then
		for i=1, self.numFuelMeter do
			setVisibility(self.fuelMeter[i].rotNode,false);
		end;
		self.prevousFuelPercentage = math.floor(currentFuelPercentage);
		for i=1, self.prevousFuelPercentage do
			setVisibility(self.fuelMeter[i].rotNode,true);
		end;
	end;
	
	-- Display handling done
	
	-- Lift Arm simulation
	if self.lifterArmLower ~= nil and self.lifter ~= nil then
		local x,y,z = getRotation(self.lifterArmLower);
		if self.lifterStartAngle == 0 and x ~= 0 then
			self.lifterStartAngle = x;
		end;
		
		local lifterFactor = 2.12;
		local lifterRotation =  x * lifterFactor-self.lifterStartAngle * lifterFactor;
		setRotation(self.lifter, lifterRotation, y,z);
		
		local lifterAttacherFactor = 2.51;
		local lifterAttacherRotation =  self.lifterStartAngle * lifterAttacherFactor - x * lifterAttacherFactor;
		setRotation(self.lifterAttacher, lifterAttacherRotation, y,z);
		--if self.lifterAttacher ~= nil and self.lifterArmLowerAttacherJoint ~= nil then
			--local ax, ay, az = getWorldTranslation(self.lifterAttacher);
			--local bx, by, bz = getWorldTranslation(self.lifterArmLowerAttacherJoint);

			--local x, y, z = worldDirectionToLocal(getParent(self.lifterAttacher), bx-ax, by-ay, bz-az);
			--setDirection(self.lifterAttacher, x, y, z, 0, 1, 0);
			--renderText(0.5, 0.55, 0.040, string.format(z));
			
			--local x2,y2,z2 = getRotation(self.lifterAttacher);
			--if x2 <= 0 then
				--x2 = x2 * -1;
			--elseif x2 > 0 then
				--x2 = x2 + 1.57;
			--end;
			--renderText(0.5, 0.65, 0.040, string.format(x2));
			--setRotation(self.lifterAttacher,x2,y2,z2);
		--end;
	end;
	
	if self.hydraulicsJoint1 ~= nil and self.hydraulics1 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulics1);
        local bx, by, bz = getWorldTranslation(self.hydraulicsJoint1);

        local x, y, z = worldDirectionToLocal(getParent(self.hydraulics1), bx-ax, by-ay, bz-az);
        setDirection(self.hydraulics1, x, y, z, 0, 1, 0);
		setTranslation(self.push1,0,by-ay,0);
		
		
		local x2,y2,z2 = getRotation(self.hydraulics1);
		setRotation(self.hydraulics1,x2+1.57,y2,z2);
	end;
	
	if self.hydraulicsJoint2 ~= nil and self.hydraulics2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulics2);
        local bx, by, bz = getWorldTranslation(self.hydraulicsJoint2);

        local x, y, z = worldDirectionToLocal(getParent(self.hydraulics2), bx-ax, by-ay, bz-az);
        setDirection(self.hydraulics2, x, y, z, 0, 1, 0);
		setTranslation(self.push2,0,by-ay,0);
		
		
		local x2,y2,z2 = getRotation(self.hydraulics2);
		setRotation(self.hydraulics2,x2+1.57,y2,z2);
	end;
end;

function magnum7140:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    self.mirrorRotationOffsetXleft = Utils.getNoNil(getXMLFloat(xmlFile, key.."#mirrorRotationOffsetXleft"), 0);
    self.mirrorRotationOffsetYleft = Utils.getNoNil(getXMLFloat(xmlFile, key.."#mirrorRotationOffsetYleft"), 0);
	self.mirrorRotationOffsetXright = Utils.getNoNil(getXMLFloat(xmlFile, key.."#mirrorRotationOffsetXright"), 0);
    self.mirrorRotationOffsetYright = Utils.getNoNil(getXMLFloat(xmlFile, key.."#mirrorRotationOffsetYright"), 0);
	
	self.camPositionX = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionX"), 0);
	self.camPositionZ = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionZ"), 0);
end;

function magnum7140:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'mirrorRotationOffsetXleft="'..self.mirrorRotationOffsetXleft..'" mirrorRotationOffsetYleft="'..self.mirrorRotationOffsetYleft..'" mirrorRotationOffsetXright="'..self.mirrorRotationOffsetXright..'" mirrorRotationOffsetYright="'..self.mirrorRotationOffsetYright..'" camPositionX="'..self.camPositionX..'" camPositionZ="'..self.camPositionZ..'"';
    return attributes, nil;
end;

function magnum7140:onLeave()
end;

function magnum7140:draw()
	if 	self.hudEnabled ~= nil and self.hudEnabled then
		if self.shiftMode == 1 then
			renderText(0.78, 0.48, 0.020, string.format("Move camera mode[%s]",InputBinding.getButtonKeyName(InputBinding.SHIFT)));
			renderText(0.78, 0.46, 0.020, string.format("left[%s], right[%s], fwd[%s], back[%s], ",InputBinding.getButtonKeyName(InputBinding.MOVECAMLEFT), InputBinding.getButtonKeyName(InputBinding.MOVECAMRIGHT), InputBinding.getButtonKeyName(InputBinding.MOVECAMFORWARD), InputBinding.getButtonKeyName(InputBinding.MOVECAMBACK)));
			renderText(0.78, 0.44, 0.020, string.format("Reset[%s]",InputBinding.getButtonKeyName(InputBinding.MOVECAMRESET)));
		elseif self.shiftMode == 2 then
			renderText(0.78, 0.48, 0.020, string.format("Adjust left mirror mode[%s]",InputBinding.getButtonKeyName(InputBinding.SHIFT)));
			renderText(0.78, 0.46, 0.020, string.format("left[%s], right[%s], down[%s], up[%s], ",InputBinding.getButtonKeyName(InputBinding.MOVECAMLEFT), InputBinding.getButtonKeyName(InputBinding.MOVECAMRIGHT), InputBinding.getButtonKeyName(InputBinding.MOVECAMFORWARD), InputBinding.getButtonKeyName(InputBinding.MOVECAMBACK)));
		elseif self.shiftMode == 3 then
			renderText(0.78, 0.48, 0.020, string.format("Adjust right mirror mode[%s]",InputBinding.getButtonKeyName(InputBinding.SHIFT)));
			renderText(0.78, 0.46, 0.020, string.format("left[%s], right[%s], down[%s], up[%s], ",InputBinding.getButtonKeyName(InputBinding.MOVECAMLEFT), InputBinding.getButtonKeyName(InputBinding.MOVECAMRIGHT), InputBinding.getButtonKeyName(InputBinding.MOVECAMFORWARD), InputBinding.getButtonKeyName(InputBinding.MOVECAMBACK)));
		end;
		
		if not self.mirrorsEnabled then
			renderText(0.78, 0.42, 0.020, string.format("Mirrors off[%s]",InputBinding.getButtonKeyName(InputBinding.ACTIVATEMIRRORS)));
		else
			renderText(0.78, 0.42, 0.020, string.format("Mirrors on[%s]",InputBinding.getButtonKeyName(InputBinding.ACTIVATEMIRRORS)));
		end;
		
		renderText(0.78, 0.38, 0.020, string.format("Adjust Liftdepth[%s/%s]",InputBinding.getButtonKeyName(InputBinding.INCREASELIFTDEBTH), InputBinding.getButtonKeyName(InputBinding.DECRESELIFTDEBTH)));
				
		renderText(0.78, 0.20, 0.020, string.format("Deactivate HUD[%s]",InputBinding.getButtonKeyName(InputBinding.HUD)));
	else
		renderText(0.78, 0.20, 0.020, string.format("Activate HUD[%s]",InputBinding.getButtonKeyName(InputBinding.HUD)));
	end;
	
	
end;
